diff -u --recursive --new-file redmine_backup/vendor/plugins/redcase//app/views/redcase/_execution_list.rhtml redmine/vendor/plugins/redcase//app/views/redcase/_execution_list.rhtml
--- redmine_backup/vendor/plugins/redcase//app/views/redcase/_execution_list.rhtml	2011-02-05 08:56:51.000000000 +0000
+++ redmine/vendor/plugins/redcase//app/views/redcase/_execution_list.rhtml	2012-01-06 23:04:38.000000000 +0000
@@ -4,18 +4,45 @@
 
 <% form_for :list2, :url => { :action => 'update_exelists', :project_id => @project.id } do |f| %>
     <div>
-        <h3 id="execution-settings-suite">
-            Execution suite:
+<table>
+<tr>
+<td>
+<h3 id="execution-settings-suite">
+            <%= l('label_execution_suite') %>:
+            </h3>
+</td>            
+<td>
+<h3 id="execution-settings-suite">
             <%= f.select :id, @lists2.collect { |e| [ e.name, e.id ] } %>
         </h3>
+        </td>
+</tr>
+<tr>
+<td>
         <h3 id="execution-settings-version">
-            Version:
+            <%= l('label_version') %>:
+            </h3>
+</td>            
+<td>
+<h3 id="execution-settings-version">
             <%= select_tag 'version', options_for_select(Version.find_all_by_project_id(@project.id).collect { |res| res.name }, @version.name ) %>
         </h3>
+        </td>
+</tr>
+<tr>
+<td>
         <h3 id="execution-settings-environment">
-            Environment:
+            <%= l('label_environment') %>:
+            </h3>
+</td>            
+<td>
+<h3 id="execution-settings-environment">
             <%= select_tag 'environments', options_for_select(ExecutionEnvironment.find(:all, :conditions => "project_id = #{@project.id}", :order => 'name asc').collect { |res| [res.name, res.id] }) %>
         </h3>
+</td>
+</tr>
+</table>
+<br/>
         <%= observe_field :list2_id, :function => 'update_exe2_tree()', :with => 'list2_id' %>
     </div>
     <br/>
diff -u --recursive --new-file redmine_backup/vendor/plugins/redcase//app/views/redcase/_execution.rhtml redmine/vendor/plugins/redcase//app/views/redcase/_execution.rhtml
--- redmine_backup/vendor/plugins/redcase//app/views/redcase/_execution.rhtml	2011-02-05 08:56:51.000000000 +0000
+++ redmine/vendor/plugins/redcase//app/views/redcase/_execution.rhtml	2012-01-06 22:04:16.000000000 +0000
@@ -12,24 +12,24 @@
         </td>
 
         <td id="execution_test_case_info_id" class="last-cell">
-            <h3>Execution info</h3>
+            <h3><%= l('label_execution_info') %></h3>
             <div id="test-case-edit" style="display: none">
                 <div id="exec_descr_id" class="issue status-2 priority-2 created-by-me details">
                     <h2>
                         <div style="font-weight: bold" id="test-case-subj" class="wiki"></div>
                     </h2>
-                    <div style="font-weight: bold">Description:</div>
+                    <div style="font-weight: bold"><%= l('label_description') %>:</div>
                     <div id="test-case-desc" class="wiki"></div>
                     <div id="test-case-attach" class="wiki"></div>
                 </div>
-                Comment:
+                <%= l('label_comment') %>:
                 <br/>
                 <%= text_area_tag 'exec-comment', nil, :rows => 4, :style => 'width: 95%' %>
                 <br/>
-                Result:
+                <%= l('label_result') %>:
                 <%= select_tag 'results', options_for_select(ExecutionResult.find(:all, :order => 'order_num asc').collect { |res| res.name }) %>
                 &nbsp;
-                <%= submit_tag 'Save', :onclick => 'execute()' %>
+                <%= submit_tag l(:label_button_save), :onclick => 'execute()' %>
                 <br/>
             </div>
         </td>
@@ -42,7 +42,7 @@
     <tr>
         <td>
             <fieldset class="tabular redcase-content" style="height: auto">
-                <legend class="redcase-header">History</legend>
+                <legend class="redcase-header"><%= l('label_history') %></legend>
                 <div id="all-results"/>
             </fieldset>
         </td>
diff -u --recursive --new-file redmine_backup/vendor/plugins/redcase//app/views/redcase/_management_environments.rhtml redmine/vendor/plugins/redcase//app/views/redcase/_management_environments.rhtml
--- redmine_backup/vendor/plugins/redcase//app/views/redcase/_management_environments.rhtml	2011-01-10 19:11:05.000000000 +0000
+++ redmine/vendor/plugins/redcase//app/views/redcase/_management_environments.rhtml	2012-01-06 09:56:32.000000000 +0000
@@ -5,7 +5,7 @@
 <!-- AJAX form to manage test environments -->
 <% remote_form_for :env, :url => { :action => 'update_environment', :project_id => @project.id, :act => 'save' }, :update => :management_environments_id, :complete => 'full()', :html => { :id => 'environment_form_id' }  do |f| %>
 	<h3>
-        Environment: <%= f.select :id, environments.collect { |e| [ e.name, e.id ] } %>
+        <%= l('label_environment') %>: <%= f.select :id, environments.collect { |e| [ e.name, e.id ] } %>
         <%= observe_field :env_id, :url => { :action => 'update_environment', :project_id => @project.id }, :with => 'env_id', :update => :management_environments_id %>
     </h3>
     <p>
diff -u --recursive --new-file redmine_backup/vendor/plugins/redcase//app/views/redcase/_management_execution_suites.rhtml redmine/vendor/plugins/redcase//app/views/redcase/_management_execution_suites.rhtml
--- redmine_backup/vendor/plugins/redcase//app/views/redcase/_management_execution_suites.rhtml	2011-02-05 14:11:46.000000000 +0000
+++ redmine/vendor/plugins/redcase//app/views/redcase/_management_execution_suites.rhtml	2012-01-06 10:28:07.000000000 +0000
@@ -27,7 +27,7 @@
 <!-- AJAX form to manage execution suites -->
 <% remote_form_for :list, :url => { :action => 'update_exelists', :project_id => @project.id, :act => 'save' }, :update => :management_execution_suites_id, :complete => 'full()', :html => { :id => 'list_form' } do |f| %>
 	<h3>
-        Execution suite: <%= f.select :id, @lists.collect { |e| [ e.name, e.id ] } %>
+        <%= l('label_execution_suite') %>: <%= f.select :id, @lists.collect { |e| [ e.name, e.id ] } %>
         <%= observe_field :list_id, :function => 'update_exe_tree()', :with => 'list_id' %>
     </h3>
     <p>
diff -u --recursive --new-file redmine_backup/vendor/plugins/redcase//app/views/redcase/_management.rhtml redmine/vendor/plugins/redcase//app/views/redcase/_management.rhtml
--- redmine_backup/vendor/plugins/redcase//app/views/redcase/_management.rhtml	2011-01-10 19:11:05.000000000 +0000
+++ redmine/vendor/plugins/redcase//app/views/redcase/_management.rhtml	2012-01-06 09:54:10.000000000 +0000
@@ -6,7 +6,7 @@
 
         <!-- Test suites management -->
         <td id="management_test_suites_id">
-            <h3>Test suites</h3>
+            <h3><%= l('label_test_suites') %></h3>
             <div id="management_test_suite_tree_id"/>
         </td>
 
diff -u --recursive --new-file redmine_backup/vendor/plugins/redcase//app/views/redcase/_report_combos.rhtml redmine/vendor/plugins/redcase//app/views/redcase/_report_combos.rhtml
--- redmine_backup/vendor/plugins/redcase//app/views/redcase/_report_combos.rhtml	2011-01-10 19:11:05.000000000 +0000
+++ redmine/vendor/plugins/redcase//app/views/redcase/_report_combos.rhtml	2012-01-08 00:51:24.000000000 +0000
@@ -1,15 +1,15 @@
-
-Version:&nbsp;
-<%= select_tag(:versionx, options_from_collection_for_select(Version.find_all_by_project_id(@project.id), 'id', 'name', @version.id), :style => 'width: 85px') %>
-<%= observe_field :versionx, :url => { :action => 'update_combos', :project_id => @project.id, :environment_id => @environment.id }, :with => 'version_id', :update => 'combos_id' %>
-<%= observe_field :versionx, :url => { :action => 'get_graph', :project_id => @project.id, :environment_id => @environment.id }, :with => 'version_id', :update => 'chart_id' %>
-<%= observe_field :versionx, :url => { :action => 'get_advanced_execution', :project_id => @project.id, :environment_id => @environment.id }, :with => 'version_id', :update => 'report_results_table_id' %>
-<%= observe_field :versionx, :url => { :action => 'update_combos2', :project_id => @project.id, :time => Time.now, :environment_id => @environment.id }, :with => 'version_id', :update => 'download_button_id' %>
-&nbsp;
-
-Environment:&nbsp;
-<%= select_tag :environment, options_from_collection_for_select(ExecutionEnvironment.find_all_by_project_id(@project.id), 'id', 'name', @environment.id), :style => 'width: 125px' %>
+<table><tr><td>
+<%= l('label_version') %>:</td><td>
+<%= select_tag(:versionx, options_from_collection_for_select(Version.find_all_by_project_id(@project.id), 'id', 'name', @version.id), :style => 'width: 225px') %>
+<%= observe_field :versionx, :url => { :action => 'update_combos', :project_id => @project.id, :environment_id => @environment.id}, :with => 'version_id', :update => 'combos_id' %>
+<%= observe_field :versionx, :url => { :action => 'get_graph', :project_id => @project.id, :environment_id => @environment.id}, :with => 'version_id', :update => 'chart_id' %>
+<%= observe_field :versionx, :url => { :action => 'get_advanced_execution', :project_id => @project.id, :environment_id => @environment.id}, :with => 'version_id', :update => 'report_results_table_id' %>
+<%= observe_field :versionx, :url => { :action => 'update_combos2', :project_id => @project.id, :time => Time.now, :environment_id => @environment.id}, :with => 'version_id', :update => 'download_button_id' %>
+</td></tr><tr><td>
+<%= l('label_environment') %>:</td><td>
+<%= select_tag :environment, options_from_collection_for_select(ExecutionEnvironment.find_all_by_project_id(@project.id), 'id', 'name', @environment.id), :style => 'width: 225px' %>
 <%= observe_field :environment, :url => { :action => 'update_combos', :project_id => @project.id, :version_id => @version.id }, :with => 'environment_id', :update => 'combos_id' %>
 <%= observe_field :environment, :url => { :action => 'get_graph', :project_id => @project.id, :version_id => @version.id }, :with => 'environment_id', :update => 'chart_id' %>
 <%= observe_field :environment, :url => { :action => 'get_advanced_execution', :project_id => @project.id, :version_id => @version.id }, :with => 'environment_id', :update => 'report_results_table_id' %>
-<%= observe_field :environment, :url => { :action => 'update_combos2', :project_id => @project.id, :time => Time.now, :version_id => @version.id }, :with => 'environment_id', :update => 'download_button_id' %>
\ No newline at end of file
+<%= observe_field :environment, :url => { :action => 'update_combos2', :project_id => @project.id, :time => Time.now, :version_id => @version.id}, :with => 'environment_id', :update => 'download_button_id' %>
+</td></tr></table>
diff -u --recursive --new-file redmine_backup/vendor/plugins/redcase//app/views/redcase/_report_results.rhtml redmine/vendor/plugins/redcase//app/views/redcase/_report_results.rhtml
--- redmine_backup/vendor/plugins/redcase//app/views/redcase/_report_results.rhtml	2011-01-10 19:11:05.000000000 +0000
+++ redmine/vendor/plugins/redcase//app/views/redcase/_report_results.rhtml	2012-01-06 10:35:47.000000000 +0000
@@ -21,14 +21,14 @@
 
 <table class="redcase-row" style="width: 100%; margin: 0px; text-align: center">
     <tr style="font-weight: bold; background-color: #507aaa; color: white; text-align: center; vertical-align: top">
-        <td style="width: 45px; vertical-align: middle; border-left-width: 0px; border-top-width: 0px; padding: 6px">ID</td>
-        <td style="width: 110px; vertical-align: middle; border-top-width: 0px; padding: 6px">Name</td>
-        <td style="width: 80px; vertical-align: middle; border-top-width: 0px; padding: 6px">Date</td>
+        <td style="width: 45px; vertical-align: middle; border-left-width: 0px; border-top-width: 0px; padding: 6px"><%= l('label_id') %></td>
+        <td style="width: 110px; vertical-align: middle; border-top-width: 0px; padding: 6px"><%= l('label_name') %></td>
+        <td style="width: 80px; vertical-align: middle; border-top-width: 0px; padding: 6px"><%= l('label_date') %></td>
         <td style="width: 115px; vertical-align: middle; border-top-width: 0px; padding: 6px">
             <%= select('filter_id', nil, ExecutionResult.all.collect { |x| [x.name, x.id] } << ['All results', 0], { :selected => 0 }, { :style => 'width: 100%' }) %>
             <%= observe_field 'filter_id_', :function => "refresh()" %>
         </td>
-        <td style="vertical-align: middle; border-top-width: 0px; padding: 6px">Executor</td>
+        <td style="vertical-align: middle; border-top-width: 0px; padding: 6px"><%= l('label_executor') %></td>
         <td style="width: 25px; vertical-align: middle; border-right-width: 0px; border-top-width: 0px; padding: 6px">&nbsp;</td>
     </tr>
     <% @results.each do |x| %>
diff -u --recursive --new-file redmine_backup/vendor/plugins/redcase//assets/javascripts/scripts.js redmine/vendor/plugins/redcase//assets/javascripts/scripts.js
--- redmine_backup/vendor/plugins/redcase//assets/javascripts/scripts.js	2011-01-10 19:16:37.000000000 +0000
+++ redmine/vendor/plugins/redcase//assets/javascripts/scripts.js	2012-01-07 20:10:08.000000000 +0000
@@ -21,7 +21,6 @@
 Ext.dd.StatusProxy.prototype.animRepair = false;
 Ext.QuickTips.init();
 Ext.chart.Chart.CHART_URL = '/plugin_assets/redcase/javascripts/ext-3.1.1/resources/charts.swf';
-
 Ext.override(Ext.tree.TreeNodeUI,
 {
 	renderElements: function(n, a, targetNode, bulkRender)
@@ -239,8 +238,12 @@
 
 function request(method, params, success, failureMsg)
 {
-	params.format = 'json';
-	conn = new Ext.data.Connection();
+        params.format = 'json';
+	conn = new Ext.data.Connection();
+        var csrf = Ext.select("meta[name='csrf-token']").first();
+        Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
+
+        conn.defaultHeaders = Ext.apply(conn.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 	conn.request(
 	{
 		url     : context + method,
@@ -258,7 +261,9 @@
  * Moving test case inside 'Test cases' tree.
  */
 function onMove(dropEvent)
-{
+{
+        var csrf = Ext.select("meta[name='csrf-token']").first();
+        Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 	if(dropEvent.dropNode.isLeaf())
 	{
 		request(
@@ -306,7 +311,10 @@
 function onxMove(dropEvent)
 {
 	conn = new Ext.data.Connection();
-
+        
+        var csrf = Ext.select("meta[name='csrf-token']").first();
+        Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
+        conn.defaultHeaders = Ext.apply(conn.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 	if(dropEvent.dropNode.isLeaf())
 	{
 		if(dropEvent.target.getOwnerTree() != dropEvent.dropNode.getOwnerTree())
@@ -425,7 +433,12 @@
 	{
 		if (btn == 'ok')
 		{
-			conn = new Ext.data.Connection();
+			conn = new Ext.data.Connection();
+                        
+
+                        var csrf = Ext.select("meta[name='csrf-token']").first();
+                        Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
+                        conn.defaultHeaders = Ext.apply(conn.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 			conn.request(
 			{
 				url     : 'redcase/test_suite_manager',
@@ -463,7 +476,9 @@
 
 	parentNode = currentNode.parentNode;
 	conn = new Ext.data.Connection();
-
+        var csrf = Ext.select("meta[name='csrf-token']").first();
+        Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});        
+        conn.defaultHeaders = Ext.apply(conn.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 	if(currentNode.isLeaf())
 	{
 		conn.request(
@@ -520,7 +535,9 @@
 
 	parentNode = currentNode.parentNode;
 	conn = new Ext.data.Connection();
-
+        var csrf = Ext.select("meta[name='csrf-token']").first();
+        Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
+        conn.defaultHeaders = Ext.apply(conn.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 	conn.request(
 	{
 		url    : 'redcase/reassign_test_case',
@@ -548,7 +565,10 @@
 	{
 		if (btn == 'ok')
 		{
-			conn = new Ext.data.Connection();
+			conn = new Ext.data.Connection();
+                        var csrf = Ext.select("meta[name='csrf-token']").first();
+                        Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')}); 
+                        conn.defaultHeaders = Ext.apply(conn.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 			conn.request(
 			{
 				url     : 'redcase/execution_suite_manager',
@@ -591,7 +611,10 @@
 		return;
 	}
 	parentNode = currentNode.parentNode;
-	conn = new Ext.data.Connection();
+	conn = new Ext.data.Connection();
+        var csrf = Ext.select("meta[name='csrf-token']").first();
+        Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});        
+        conn.defaultHeaders = Ext.apply(conn.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 	conn.disableCaching = false;
 	if (currentNode.isLeaf())
 	{
@@ -620,7 +643,9 @@
 
 	parentNode = xcurrentNode.parentNode;
 	conn = new Ext.data.Connection();
-
+        var csrf = Ext.select("meta[name='csrf-token']").first();
+        Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
+        conn.defaultHeaders = Ext.apply(conn.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 	if (xcurrentNode.isLeaf())
 	{
 		conn.request(
@@ -741,7 +766,10 @@
 
 	editorSuite.on('beforecomplete', function(editor, newValue, originalValue) {
 
-		conn = new Ext.data.Connection();
+		conn = new Ext.data.Connection();
+                var csrf = Ext.select("meta[name='csrf-token']").first();
+                Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
+                conn.defaultHeaders = Ext.apply(conn.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 
 		conn.request({
 			url: 'redcase/test_suite_manager',
@@ -774,7 +802,9 @@
 	editorExec.on('beforecomplete', function(editor, newValue, originalValue) {
 
 		conn = new Ext.data.Connection();
-
+                var csrf = Ext.select("meta[name='csrf-token']").first();
+                Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
+                conn.defaultHeaders = Ext.apply(conn.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 		conn.request({
 			url: 'redcase/execution_suite_manager',
 			method: 'GET',
@@ -864,15 +894,16 @@
 		return findNext(next);
 	}
 }
-
-
-function execute() {
+function execute() {
 	node = exec2Tree.getSelectionModel().getSelectedNode();
 	result = Ext.get('results');
 	envs = Ext.get('environments');
 	version = Ext.get('version');
 	comment = Ext.get('exec-comment');
-	conn = new Ext.data.Connection();
+	conn = new Ext.data.Connection();
+        var csrf = Ext.select("meta[name='csrf-token']").first();
+        Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
+        conn.defaultHeaders = Ext.apply(conn.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 	Element.show('ajax-indicator');
 	conn.request({
 		url: 'redcase/execute',
@@ -883,7 +914,7 @@
 			"version": version.getValue(false),
 			"result": result.getValue(false),
 			"envs": envs.getValue(false),
-			"comment": comment.getValue(false),
+			"comment": comment.getValue(false),
 			"format": "json"
 		},
 		success: function(responseObject) {
@@ -912,7 +943,9 @@
 	r = Ext.get('all-results-d');
 	r.setDisplayed('none');
 	if (node.isLeaf()) {
-		conn = new Ext.data.Connection();
+		conn = new Ext.data.Connection();
+                var csrf = Ext.select("meta[name='csrf-token']").first();
+                Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 		Element.show('ajax-indicator');
 		conn.request({
 			waitMsg: 'loading test case info',
@@ -999,9 +1032,9 @@
 
 function getHistory(rs)
 {
-	unique = {}
-	txt = "<table class='redcase-row' width='100%'>"
-	txt += "<tr style='font-weight: bold; background-color: #eeeeee'><td>Date</td><td>Result</td><td>Comments</td><td>Executor</td><td>Environment</td><td>Version</td></tr>"
+	unique = {}
+        txt = "<table class='redcase-row' width='100%'>"
+        txt += "<tr style='font-weight: bold; background-color: #eeeeee'><td>date</td><td>result</td><td>comments</td><td>executor</td><td>environment</td><td>version</td></tr>";
 	for(i = 0; i < rs.length; i++) {
 		switch (rs[i].result)
 		{
@@ -1076,11 +1109,11 @@
 function update_exe_tree()
 {
 	choosen = Ext.get('list_id').getValue(false);
-	conn = new Ext.data.Connection();
+	conn = new Ext.data.Connection();
+        var csrf = Ext.select("meta[name='csrf-token']").first();
+        Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 	nameEl = Ext.get('list_name');
-
 	Element.show('ajax-indicator');
-
 	conn.request(
 	{
 		url     : 'redcase/index',
@@ -1113,7 +1146,8 @@
 {
 	choosen = Ext.get('list2_id').getValue(false);
 	conn = new Ext.data.Connection();
-
+        var csrf = Ext.select("meta[name='csrf-token']").first();
+        Ext.Ajax.defaultHeaders = Ext.apply(Ext.Ajax.defaultHeaders || {}, {'X-CSRF-Token': csrf.getAttribute('content')});
 	Element.show('ajax-indicator');
 
 	conn.request(
diff -u --recursive --new-file redmine_backup/vendor/plugins/redcase//assets/stylesheets/styles.css redmine/vendor/plugins/redcase//assets/stylesheets/styles.css
--- redmine_backup/vendor/plugins/redcase//assets/stylesheets/styles.css	2011-01-10 19:16:37.000000000 +0000
+++ redmine/vendor/plugins/redcase//assets/stylesheets/styles.css	2012-01-06 23:17:47.000000000 +0000
@@ -70,7 +70,8 @@
 
 #execution-settings-suite select
 {
-	border: 1px navy solid;
+	border: 1px navy solid;
+        width: 250px; 
 }
 
 #execution-settings-version
@@ -80,7 +81,8 @@
 
 #execution-settings-version select
 {
-	border: 1px purple solid;
+	border: 1px purple solid;
+        width: 250px;
 }
 
 #execution-settings-environment
@@ -90,7 +92,8 @@
 
 #execution-settings-environment select
 {
-	border: 1px maroon solid;
+	border: 1px maroon solid;
+        width: 250px;
 }
 
 #execution_test_case_info_id h3
@@ -465,4 +468,4 @@
 {
 	line-height:inherit;
         font-size:inherit;
-}
\ No newline at end of file
+}
diff -u --recursive --new-file redmine_backup/vendor/plugins/redcase//config/locales/de.yml redmine/vendor/plugins/redcase//config/locales/de.yml
--- redmine_backup/vendor/plugins/redcase//config/locales/de.yml	1970-01-01 00:00:00.000000000 +0000
+++ redmine/vendor/plugins/redcase//config/locales/de.yml	2012-01-06 22:09:27.000000000 +0000
@@ -0,0 +1,27 @@
+# German strings go here for Rails i18n
+
+de:
+  label_test_case_management     : "Management"
+  label_test_case_execution      : "Durchf&uuml;hrung"
+  label_test_case_report         : "Auswertung"
+  label_test_suites              : "Testreihen"
+  label_execution_suite          : "Ausf&uuml;hrungsfolgen"
+  label_environment              : "Testumgebung"
+  label_version                  : "Version"
+  label_execution_info           : "Ausf&uuml;hrungsbeschreibung"
+  label_description              : "Beschreibung"
+  label_history                  : "Verlauf"
+  label_id                       : "Nr"
+  label_name                     : "Name"
+  label_date                     : "Datum"
+  label_result                   : "Ergebnis"
+  label_comments                 : "Kommentare"
+  label_comment                  : "Kommentar"
+  label_executor                 : "Ausf&uuml;hrer"
+  label_not_available            : "Nicht verf&uuml;gbar"
+  label_report                   : "Auswertung"
+  label_full_report              : "Vollst&auml;ger Bericht"
+  label_test_case_specification  : "Testfallspezifikation"
+  label_button_save              : "Speichern"
+
+
diff -u --recursive --new-file redmine_backup/vendor/plugins/redcase//config/locales/en.yml redmine/vendor/plugins/redcase//config/locales/en.yml
--- redmine_backup/vendor/plugins/redcase//config/locales/en.yml	2011-01-10 19:16:37.000000000 +0000
+++ redmine/vendor/plugins/redcase//config/locales/en.yml	2012-01-06 22:02:09.000000000 +0000
@@ -4,4 +4,27 @@
 
   label_test_case_management : "Management"
   label_test_case_execution  : "Execution"
-  label_test_case_report     : "Report"
+  label_test_case_report     : "Report"
+  label_test_suites              : "Test suites"
+  label_execution_suite          : "Execution suite"
+  label_environment              : "Environment"
+  label_version                  : "Version"
+  label_execution_info           : "Execution Info"
+  label_description              : "Description"
+  label_history                  : "History"
+  label_id                       : "ID"
+  label_name                     : "Name"
+  label_date                     : "Date"
+  label_result                   : "Result"
+  label_comments                 : "Comments"
+  label_comment                  : "Comment"
+  label_executor                 : "Executor"
+  label_not_available            : "Not Available"
+  label_report                   : "Report"
+  label_full_report              : "Full Report"
+  label_test_case_specification  : "Test case specification"
+  label_button_save              : "save"
+
+
+
+